
#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "MainDlg.h"
#include "tabasa_recorder.h"


void setwaveformRec(WAVEFORMATEX &wf,int format,int channels,long rate,int samplesize)
{
	wf.wFormatTag      = format ;
	wf.nChannels       = channels ;
	wf.nSamplesPerSec  = rate ;
	wf.nAvgBytesPerSec = samplesize/8*channels*rate ;
	wf.nBlockAlign     = samplesize/8*channels;
	wf.wBitsPerSample  = samplesize ;
	wf.cbSize          = 0 ;
}

void setwaveformPl(WAVEFORMATEX &wf,int format,int channels,long rate,int samplesize)
{
	if(samplesize ==24 && play16bitflag) samplesize = 16 ;
	setwaveformRec(wf, format, channels, rate, samplesize);
}


void SetWaveHdr(PWAVEHDR &pWaveHdr,PBYTE &pBuffer,ULONG size,DWORD flag,DWORD dwRepetitions)
{
	pWaveHdr->lpData          = (char *)pBuffer ;
	pWaveHdr->dwBufferLength  = size ;
	pWaveHdr->dwBytesRecorded = 0 ;
	pWaveHdr->dwUser          = 0 ;
	pWaveHdr->dwFlags         = flag ;//
	pWaveHdr->dwLoops         = dwRepetitions ;
	pWaveHdr->lpNext          = NULL ;
	pWaveHdr->reserved        = 0 ;
}


void setVolume(int left, int right,HWAVEOUT hWaveOut)//magazine.interface,2000/8/..mp3
{
	int maxVol	 = 0xFFFF;
	int leftVol	 = left * maxVol / 100;
	int rightVol = right * maxVol / 100;
	int vol = MAKELONG(leftVol, rightVol);

	::waveOutSetVolume(hWaveOut, vol);//MMRESULT mmresult = 
//	if (mmresult != MMSYSERR_NOERROR) {
//		throw MMException(mmresult);
//	}
}

BOOL DlgRateMain(WORD id)
{
	switch (id)
	{
		case IDC_RATE_RESET:
			raterate=ratedefault;
			rate=ratebase*raterate;
			settext(IDC_EDIT_RATE,rate,"");
			settexts(NULL);
			SendMessage (mainhwnd, WM_COMMAND, IDC_PLAY_restart_if, 0) ;
			return TRUE ;

		case IDC_RATE_SET:
			gettextdata(IDC_EDIT_RATE2, rate);
			settext(IDC_EDIT_RATE,rate,"");
			settexts(NULL);
			SendMessage (mainhwnd, WM_COMMAND, IDC_PLAY_restart_if, 0) ;
			return TRUE ;


		case IDC_RATE_UP:
			if(raterate<1)raterate*=2;
			else if(raterate<ratemax)raterate++;
			rateupdown();
			return TRUE ;

		case IDC_RATE_DOWN:
			if(raterate>1)raterate--;
			else raterate/=2;
			rateupdown();
			return TRUE ;//
	}
	return TRUE;
}