
#include "defextern.h"

#include <stdio.h>
//#include <iostream.h>
//#include <fstream.h>
#include <windows.h>
#include "hdc.h"
#include "resource.h"
#include "file.h"
#include "tabasa_recorder.h"
#include "wav8bit.h"
#include "fileeditDlg.h"
#include "recOptionDlg.h"
#include "scroll.h"
#include "WaveEditOnPlaying.h"
#include "waveeditDlg.h"
#include "SubSoundPlayDlg.h"
#include "SubSoundSetting.h"
#include "FileSave.h"
#include "SoundFileIO.h"
#include "MainDlg.h"
#include "SoundBuffer.h"
#include "SoundBufferMain.h"
#include "wavetrack.h"
#include "time.h"
#include "wavepic.h"

HPEN penline=CreatePen(PS_SOLID,1,RGB(200,0,100));
HPEN penb=CreatePen(PS_SOLID,1,RGB(255,255,255));

#define id_timer 1

void showdata(HDC &hdc,long value,int gyo)
{
	char buffer[10];
	wsprintf(buffer,"%ld",value);
	TextOut(hdc,0,gyo*15,buffer,strlen(buffer));
}

#define nowmark(x,y,yl) {\
			LINE(x-5,y,x,y-5);\
			LINE(x+5,y,x,y-5);\
			LINE(x,y,x,y-15);\
			LINE(x-5,yl,x,yl+5);\
			LINE(x+5,yl,x,yl+5);\
			LINE(x,yl,x,yl+15);\
			LINE(x,center-5,x,center+5);}

void SetPicTimer(HWND &hwnd)
{
	timercount=0;
	timerinterval=72;
	timercountmax =(float)membuffersize/((ULONG)((float)channels*2*rate/1000*timerinterval))-1;
	SetTimer(hwnd,id_timer,timerinterval,NULL);
}

void KillPicTimer(HWND &hwnd)
{
	KillTimer(hwnd,id_timer);
}

float calcwav(short *startp, int i, int bit)
{
	if(bit>8) return (*(short*)((char*)startp+i*bit/4+4));
	return (*((unsigned char*)startp+i*2))*256-bit16max;
}

//-----------------------------------------------------------------------
//	WAVE 摜

LRESULT CALLBACK WaveLProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;
	 HDC hdc;
	 int i,imaxbase=wavelpicxl/4*4,imax,center=wavelpicyl/2,plotmax;
	 long xlast,ylast,x,y;
	 static short *startp;
	 static long wavemax=bit16max;
	 static long scale=(float)wavemax/wavelpicyl*2.1;
	 static long scalespec=2;
	 static long scalespecx=5;
	 static ULONG nowpos=0;

     //int id = GetWindowLong (hwnd, GWL_ID) ;
	//HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
	char buff[50];
          
	
     switch (message)
     {


	 case WM_PAINT:
			hdc=BeginPaint(hwnd,&paintstruct);
			SelectObject(hdc,GetStockObject(BLACK_PEN));
			SelectObject(hdc,GetStockObject(BLACK_BRUSH));
			imax =imaxbase/wavepicshowratex;
			Rectangle(hdc,0,0,imaxbase,center*2);
		 if(!picflag || !Lpicflag) ;
		 else if(specflag)
		 {
			 pSpecBuffer= nowbuffer;
			startp=(short*)pSpecBuffer;
			SelectObject(hdc,penb);
			//LINE(0,center,imax,center);
			LINE(0,center+wavemax/scale,imax,center+wavemax/scale);
			LINE(0,center-wavemax/scale,imax,center-wavemax/scale);
			xlast=0;
			ylast=*((unsigned short*)startp);
			plotmax=min(readspeedsize/4,imax);
			for(i=0;i<plotmax-1;i++)
			{
				x=i*scalespecx;
				y=*(startp+i*2);
				y =-checkoverflow16bitu( y * wavepicshowrate *scalespec );
				LINE(x,center+wavemax/scale,x,center+wavemax/scale+y/scale);
				xlast=x;
				ylast=y;
			}
		 }
		 else
		{
			startp=(short*)pWavepicBuffer +(ULONG)((float)timercount*channels*rate/1000)*timerinterval;
			SelectObject(hdc,penline);
			LINE(0,center,imaxbase,center);
			LINE(0,center+wavemax/scale,imaxbase,center+wavemax/scale);
			LINE(0,center-wavemax/scale,imaxbase,center-wavemax/scale);
			xlast=0;
			ylast=-*(startp);
			plotmax=min((membuffersize/2-(ULONG)((float)timercount*rate/1000*timerinterval)-1)/2,imax-3);
			SelectObject(hdc,penb);
			if(samplesize==8) for(i=0;i<plotmax-1;i++)
			{
				x=i*wavepicshowratex;
				y=(*((unsigned char*)startp+i*2))*256-bit16max;
				y =checkoverflow16bit( y * wavepicshowrate );
				LINE(xlast,ylast/scale+center,x,y/scale+center);
				xlast=x;
				ylast=y;
			}
			else //if(samplesize>=16)
				for(i=0;i<plotmax-1;i++)
			{
				x=i*wavepicshowratex;
				y=-calcwav(startp,i,samplesize);
				y =checkoverflow16bit( y * wavepicshowrate );
				LINE(xlast,ylast/scale+center,x,y/scale+center);
				xlast=x;
				ylast=y;
			}
			wavL.setvalue(*(startp+editoffset*2));
			wavR.setvalue(*(startp+editoffset*2+1));
			showpos();
			x=editoffset*wavepicshowratex;
			SelectObject(hdc,penline);
			nowmark(x,center+wavemax/scale,center-wavemax/scale);
		 }
		EndPaint(hwnd,&paintstruct);
		 break;

	case WM_KILLFOCUS:
		break ;  

	case WM_DESTROY:
		DeleteObject(penline);
		DeleteObject(penb);
		break ;    
     }
	 return CallWindowProc ((FARPROC) OldWaveL, hwnd, message, wParam, lParam) ;
}

//-----------------------------------------------------------------------
//	WAVE 摜

LRESULT CALLBACK WaveRProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;
	 HDC hdc;
	 int i,imaxbase=wavelpicxl/4*4,imax,center=wavelpicyl/2,plotmax;
	 long xlast,ylast,x,y;
	 static short *startp;
	 static long wavemax=bit16max;
	 static long scale=(float)wavemax/wavelpicyl*2.1;
	 static ULONG nowpos=0;

     //int id = GetWindowLong (hwnd, GWL_ID) ;
	//HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
	char buff[50];
          
	
     switch (message)
     {


	 case WM_PAINT:
			hdc=BeginPaint(hwnd,&paintstruct);
			SelectObject(hdc,GetStockObject(BLACK_PEN));
			SelectObject(hdc,GetStockObject(BLACK_BRUSH));
			imax =imaxbase/wavepicshowratex;
			Rectangle(hdc,0,0,imaxbase,center*2);
		 if(!picflag || !Rpicflag) ;
		 else
		 {
			startp=(short*)pWavepicBuffer +(ULONG)((float)timercount*channels*rate/1000)*timerinterval +samplesize/8;
			SelectObject(hdc,penline);
		LINE(0,center,imax,center);
		LINE(0,center+(float)nextzero/100*wavemax/scale* wavepicshowrate,imaxbase,center+(float)nextzero/100*wavemax/scale* wavepicshowrate);
		LINE(0,center+wavemax/scale,imaxbase,center+wavemax/scale);
		LINE(0,center-wavemax/scale,imaxbase,center-wavemax/scale);
		xlast=0;
		ylast=-*(startp);
		plotmax=min((membuffersize/2-(ULONG)((float)timercount*rate/1000*timerinterval)-1)/2,imax-3);
		SelectObject(hdc,penb);
			//if(samplesize>=16)
			for(i=0;i<plotmax-1;i++)
			{
				x=i*wavepicshowratex;
				y=-calcwav(startp,i,samplesize);
				y =checkoverflow16bit( y * wavepicshowrate );
				LINE(xlast,ylast/scale+center,x,y/scale+center);
				xlast=x;
				ylast=y;
			}
			x=editoffset*wavepicshowratex;
			SelectObject(hdc,penline);
			nowmark(x,center+wavemax/scale,center-wavemax/scale);
		 }
		EndPaint(hwnd,&paintstruct);
		 break;

	case WM_KILLFOCUS:
		break ;     
	 }
	return CallWindowProc ((FARPROC) OldWaveR, hwnd, message, wParam, lParam) ;
}


void upwavepicrate()
{
	if(wavepicshowrate<wavepicshowrateMax)wavepicshowrate +=0.1;
}

void downwavepicrate()
{
	if(wavepicshowrate>1)wavepicshowrate -=0.1;
}

void upwavepicratex()
{
	if(wavepicshowratex<wavepicshowratexMax)
	{
		wavepicshowratex +=0.1;
		scrollminset();
		resetsoundpic();
	}
}

void downwavepicratex()
{
	if(wavepicshowratex>0.1)
	{
		wavepicshowratex -=0.1;
		scrollminset();
	resetsoundpic();
	}
}
void initwavepic()
{
	wavepicshowrate =1;
	//wavepicshowratex =1;
}

void initwavepicx()
{
	wavepicshowratex =1;
	scrollminset();
	resetsoundpic();
}

void picflagreset()
{
	picflag =TRUE;
	Lpicflag =TRUE;
	Rpicflag =TRUE;
}

void resetsoundpic()
{
	//Đł͂Ȃꍇ
	if(pSkipBuffer!=NULL && !bPlaying)
	readallsoundpic(pSkipBuffer, filename,2048/wavepicshowratex);
}



void picmain(WORD id)
{
	switch (id)
	{
		  case IDC_wavepic_showrate_1:
				initwavepic();
			  break;

		  case IDC_wavepic_showrate_down:
			  downwavepicrate();
			  break;

		  case IDC_wavepic_showrate_up:
			  upwavepicrate();
			  break;

		  case IDC_wavepic_x_showrate_1:
				initwavepicx();
				ShowWave();
			  break;

		  case IDC_wavepic_x_showrate_down:
			  downwavepicratex();
				ShowWave();
			  break;

		  case IDC_wavepic_x_showrate_up:
			  upwavepicratex();
				ShowWave();
			  break;

		  case IDC_CHANGE_WAVE:
			  picflag =!picflag;
			  break;

		  case IDC_LEVEL_CHECK_ON_REC:
			  piconrecflag =!piconrecflag;
			  break;
	}
}